 Member
!_ABCDllMode_  EQUATE(0)
!_ABCLinkMode_ EQUATE(1)

!Includes this class and others
 include('DlgTplCl.inc')
 include('StrCl.inc')
 include('osvercl.inc')
cpgmpath cstring(file:maxfilepath)

 Map
   !Local Procedures, if any, go here
   explorerhook(long phdlg, long pmsg, long pWparam, long plparam),long,pascal

   !API Prototypes
   Module('api')
      GlobalAlloc(UNSIGNED,ULONG),Unsigned,PASCAL
      GlobalFree(Unsigned),Unsigned,PASCAL,proc
      GlobalReAlloc(Unsigned, ulong, ushort),unsigned,PASCAL
      GlobalLock(Unsigned),long,pascal
      GlobalUnlock(Unsigned),Bool,pascal,proc
      memcpy(long,long,unsigned),long,Name('_memcpy'),proc
      GetOpenFileName(long),pascal,bool,proc,name('GetOpenFileNameA')
      GetSaveFileName(Long),pascal,bool,proc,name('GetSaveFileNameA')
      ofn_lstrcpy(long,long),LONG,PASCAL,RAW,NAME('lstrcpyA'),proc
      ofn_lstrcpyn(long,long,long),LONG,PASCAL,RAW,NAME('lstrcpynA'),proc
      ofn_lstrlen(long),SIGNED,PASCAL,NAME('lstrLenA')
      getlasterror(),long,pascal
      DialogBoxIndirect(long hinstance, long lpDlgTemplate, long phwnd, long lpDlgProc,long pdummy=0),long,pascal,name('DialogBoxIndirectParamA')
      CommDlgExtendedError(),long,pascal
      SendMessage(long phwnd, long pmsg, long pwparam, long plparam),long,pascal,name('SendMessageA'),raw
      getparent(long phwnd),long,pascal,proc,raw
      getdlgitem(long phdlg, long pcontrolid),long,pascal,proc,raw !returns a hwnd
      enablewindow(long phwnd, long pEnable),long,pascal,proc,raw
      setfocus(long phwnd),long,pascal,proc,raw
      iswindow(long phwnd),long,pascal,proc,raw
   End
 end

GMEM_FIXED          equate(0)
GMEM_MOVEABLE       equate(2) 
GMEM_ZEROINIT       equate(40H)
GMEM_DDESHARE       equate(2000H)

OPENFILENAMEType             GROUP,TYPE
lStructSize                   LONG
hwndOwner                     LONG
hInstance                     LONG
lpstrFilter                   LONG
lpstrCustomFilter             LONG
nMaxCustFilter                LONG
nFilterIndex                  LONG
lpstrFile                     LONG
nMaxFile                      LONG
lpstrFileTitle                LONG
nMaxFileTitle                 LONG
lpstrInitialDir               LONG
lpstrTitle                    LONG
Flags                         LONG
nFileOffset                   USHORT
nFileExtension                USHORT
lpstrDefExt                   LONG
lCustData                     LONG
lpfnHook                      Long
lpTemplateName                LONG
lpreserved                    long !only on xp/2k
dwReserved                    long !only on xp/2k
flagsEX                       long !only on xp/2k
                            END

OFN_READONLY                EQUATE(00000001h)
OFN_OVERWRITEPROMPT         EQUATE(00000002h)
OFN_HIDEREADONLY            EQUATE(00000004h)
OFN_NOCHANGEDIR             EQUATE(00000008h)
OFN_SHOWHELP                EQUATE(00000010h)
OFN_ENABLEHOOK              EQUATE(00000020h)
OFN_ENABLETEMPLATE          EQUATE(00000040h)
OFN_ENABLETEMPLATEHANDLE    EQUATE(00000080h)
OFN_NOVALIDATE              EQUATE(00000100h)
OFN_ALLOWMULTISELECT        EQUATE(00000200h)
OFN_EXTENSIONDIFFERENT      EQUATE(00000400h)
OFN_PATHMUSTEXIST           EQUATE(00000800h)
OFN_FILEMUSTEXIST           EQUATE(00001000h)
OFN_CREATEPROMPT            EQUATE(00002000h)
OFN_SHAREAWARE              EQUATE(00004000h)
OFN_NOREADONLYRETURN        EQUATE(00008000h)
OFN_NOTESTFILECREATE        EQUATE(00010000h)
OFN_NONETWORKBUTTON         EQUATE(00020000h)
OFN_NOLONGNAMES             EQUATE(00040000h)
OFN_EXPLORER                EQUATE(00080000h)
OFN_NODEREFERENCELINKS      EQUATE(00100000h)
OFN_LONGNAMES               EQUATE(00200000h)
OFN_SHAREFALLTHROUGH        EQUATE(2)
OFN_SHARENOWARN             EQUATE(1)
OFN_SHAREWARN               EQUATE(0)





!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

dlgtemplateexType group,type
dlgver ushort
signature ushort
dwhelpid  long
dwExStyle long
dwStyle   long
cDlgItems ushort
x         short
y         short
dlgwidth  short
dlgheight short
  end
  
dlgFontFieldsType group,type
pointsize ushort
weight    ushort
isitalic  byte
Charset   byte
  end 
dlgItemFixedType queue,type
dwhelpid     long
dwExStyle    long
dwstyle      long
x            short
y            short
w            short
H            short
controlid    long !max of 256 on 95/98/me
extracount   ushort
    end

!-------------------------------------------------------------
!---Start of DlgTplCl
!-------------------------------------------------------------
DlgTplClType.Init  Procedure(byte pdebug, long dwStyle, long DwExStyle, short pWidth, short pHeight, short px=0, short py=0,|
                    long dwHelpid=0,short pMenuResourceid=0, <string pmenuresourcename>, short pwindowClassID=0, <string pWindowClassName>, <string pdlgTitle>)  !,byte,proc
res byte(return:fatal)  
!for DS_ShellFont                  
loc:typefacename   string(32)
eShellTypeface equate('MS Shell Dlg')
eShellpointsize equate(8)   !8 pt
eShellweight    equate(400) !regular 
eShellIsItalic  equate(0)  !not italic
eShellCharset   equate(1) !default
  Code
  SELF.Debug=pDebug
  SELF.StrCl &= New StrClType
  SELF.DlgItemQ &= new DlgItemQType
  if SELF.StrCl &=NULL or SELF.DlgItemQ &=NULL then
    SELF.TakeError('Out of memory preparing to create a dialog.')
    do procret
  end  
  clear(SELF.cbSize) !counter fo the size of the data
  SELF.cbSize = size(dlgtemplateexType) !fixed fields site
  SELF.dwstyle = dwstyle
  SELF.DwExStyle = dwExStyle
  SELF.DlgWidth  = pWidth
  SELF.DlgHeight = pHeight
  SELF.X=pX
  SELF.Y=pY
  SELF.DwHelpID=dwhelpid
  SELF.MenuResourceID= pMenuResourceID
  SELF.WindowClassID = pWindowClassid
  if SELF.MenuResourceID and ~omitted(11) then
    SELF.TakeError('Both a menu resource ID and a menu resource name may not be specified.')
    do procret
  end
  if ~omitted(11)
    SELF.MenuResourceName &= SELF.Strcl.CWToWideStrAlloc(pMenuResourceName)
    if SELF.MenuResourceName &= NULL then
      SELF.TakeError('Out of memory converting a string.')
      do procret
    end
    SELF.cbMenuResourceName = (len(clip(pMenuResourceName))*2+2)  !+2 for doubled null on end
    SELF.cbSize += (SELF.cbMenuResourceName)
  else
    SELF.CbSize += 2 !menuid or double null
    if pmenuResourceid then SELF.cbSize+=2. !for the id
  end
  if ~omitted(13)
    SELF.WindowClassName &= SELF.StrCl.CWToWideStrAlloc(pWindowClassName)
    if SELF.WindowClassName &= NULL then
      SELF.TakeError('Out of memory converting a string.')
      do procret
    end
    SELF.cbWindowClassName = (len(clip(pWindowClassName))*2+2)
    SELF.cbSize += (SELF.cbWindowClassName)
  else
    SELF.cbSize +=2 !oFFFFH prefix or double null
    if SELF.WindowClassID then SELF.CbSize+=2.
  end
  if ~omitted(14)
    SELF.DlgTitle &= SELF.StrCl.CWtoWideStrAlloc(pDlgTitle)
    if SELF.DlgTitle &= NULL then
      SELF.TakeError('Out of memory converting a string.')
      do procret
    end
    SELF.cbDlgTitle = (len(clip(pDlgTitle)))*2+2
    SELF.cbSize += SELF.cbDlgTitle
  else
    SELF.cbSize +=2 !for double null  
  end 

  !if shellfont was specified then add the font info
  if Band(SELF.dwstyle,dS_Shellfont)=ds_shellfont then
    loc:typefacename=eshelltypeface
    !okay to add the font
    SELF.Typefacename &= SELF.StrCl.CWtoWideStrAlloc(loc:typefacename)
    if SELF.TypeFaceName &= NULL then
      SELF.TakeError('Out of memory converting a string.')
      do procret
    end
    SELF.cbTypefaceName = (len(clip(loc:TypefaceName)))*2+2
    SELF.cbSize += SELF.cbTypefaceName
    SELF.cbSize += 6 !for the pointsize, weight, italic,charset fields
    SELF.pointsize = eShellpointsize
    SELF.weight    = eShellweight
    SELF.isItalic  = eShellIsItalic
    SELF.CharSet   = eShellCharSet
  end
  
  res=return:benign
  do procret              
    
ProcRet routine     
  Return res

DlgTplClType.Kill              Procedure()
!destroy any dynamic objects and clean up
I    long,auto
recs long,auto
    Code
    if SELF.hglobal then globalfree(SELF.hglobal);clear(SELF.hglobal).
    if ~SELF.DlgItemQ &= NULL
      recs = records(SELF.DlgItemQ)
      loop i= 1 to recs
        get(SELF.DlgItemQ,I)
        dispose(SELF.DlgItemQ.ClassName)
        dispose(SELF.DlgItemQ.ResName)
      end
      dispose(SELF.DlgItemQ)
    end    
    dispose(SELF.MenuResourceName)
    dispose(SELF.WindowClassName)
    dispose(SELF.DlgTitle)
    Dispose(SELF.TypeFacename)
    Dispose(SELF.StrCl)
    clear(SELF)
    RETURN

DlgTplClType.TakeError procedure(string pmsg)
  code
  if SELF.debug then
    Message(clip(pmsg))
  end
  SELF.ErrorStr = pMsg
  return  


DlgTplClType.DlgFont   procedure(string pTypefacename, byte ppointsize, byte pisItalic, long pweight=400, long pCharset=0)
res byte(return:fatal)
  code
  if Band(SELF.dwstyle,dS_Shellfont)=ds_shellfont  then
    SELF.TakeError('DlgFont may not be called when ds_ShellFont is specified.')
    do procret
  end
  if ~Band(SELF.DwStyle,Ds_setfont) then
    SELF.takeError('DlgFont many not be called unless DS_SetFont and not DS_fixedsys is called.')
    do procret
  end  
  !okay to add the font
  SELF.Typefacename &= SELF.StrCl.CWtoWideStrAlloc(pTypefacename)
  if SELF.TypeFaceName &= NULL then
    SELF.TakeError('Out of memory converting a string.')
    do procret
  end
  SELF.cbTypefaceName = (len(clip(pTypefaceName)))*2+2
  SELF.cbSize += SELF.cbTypefaceName
  SELF.cbSize += 6 !for the pointsize, weight, italic,charset fields
  SELF.pointsize = pPointsize
  SELF.weight = pWeight
  SELF.isItalic = pisItalic
  SELF.CharSet = pCharSet
  res=return:benign
  do procret
procret routine
  return res  
  
    
DlgTplClType.additem   procedure(long pControlID, long dwhelpid, long dwstyle, long dwEXStyle, short px, short py, short pWidth, short pheight,|
                       ushort pClassID=0, <String pClassName>,  ushort pResID=0, <string pResName>, ushort cbCreationData=0, long lpCreationData=0)
res byte(return:fatal)
  code
  
  Clear(SELF.DlgItemQ) 
  SELF.DlgItemQ.dwhelpid = DwHelpid
  SELF.DlgItemQ.controlid=pControlid  
  SELF.DlgItemQ.DwStyle = dwStyle
  SELF.DlgItemQ.dwExStyle = dwExStyle
  SELF.DlgItemQ.x=px
  SELF.DlgItemQ.y=py
  SELF.DlgItemQ.w=pwidth
  SELF.DlgItemQ.h=pheight
  SELF.DlgItemQ.cbcreationData = cbCreationData
  SELF.DlgItemQ.lpCreationData = lpCreationData
  SELF.DlgItemQ.classid=pClassid
  SELF.DlgItemQ.Resid=pResid
  Add(SELF.DlgItemQ)
  if errorcode() then
    SELF.takeError('Out of memory adding a dlg item.')
    do procret
  end
  SELF.DlgItemQ.DataSize += size(dlgItemFixedType) 
  
  if ~pClassid and omitted(11) then
    SELF.TakeError('You must specify either a class id or window class name.')
    do procret
  end  
  if ~pResid and omitted(13) then
    SELF.TakeError('You must specify eithr a resource ID or text that may be intial text for a control or a resource name.')
    do procret
  end  
  
  if pClassID and ~omitted(11) then
    SELF.TakeError('You may not specify both a classname and class id.')
    do procret
  end
  if pResID and ~omitted(13) then
    SELF.TakeError('You may not specify both a resid and resname.')
    Do procret
  end 
  
  !convert strings and add their length
  if ~omitted(11)
  Message('string classname='& pclassname)
    SELF.DlgItemQ.ClassName &= SELF.StrCl.CWToWideStrAlloc(pClassName)
    if SELF.DlgItemQ.ClassName &= NULL then
      SELF.TakeError('Out of memory converting a string.')
      do procret
    end
    SELF.DlgItemQ.cbClassName = len(clip(pClassName))*2+2 !string length plus double null
    SELF.DlgItemQ.DataSize+=(SELF.DlgItemQ.cbClassName) !no prefix==2
  else
    SELF.DlgItemQ.DataSize +=4 !pClassid + 0ffffH
  end
  if ~omitted(13)
    SELF.DlgItemQ.ResName &= SELF.StrCl.CWToWideStrAlloc(pResName)
    if SELF.DlgItemQ.ResName &= NULL then
      SELF.TakeError('Out of memory converting a string.')
      do procret
    end
    SELF.DlgItemQ.cbResName = len(clip(pResName))*2+2 !string length plus double null
    SELF.DlgItemQ.DataSize+=(SELF.DlgItemQ.cbResName) !no prefix==2
  else      
    SELF.DlgItemQ.DataSize+=4 !pResid + 0ffffH
  end
  SELF.DlgItemQ.Datasize += cbCreationData
  
  
  put(SELF.DlgItemQ)
  res=return:Benign
  do procret
  
procret routine
  return res                         
DlgTplClType.gethandle procedure(*long phglobal)
res byte(return:fatal)
totalsize long,auto
I   long,auto
recs long,auto
dummylong long,auto
  code
  !init output
  clear(phglobal)

  !get the # of dlgItems added and the size of the data for the dlg itself
  recs=records(SELF.DlgItemQ)
  TotalSize=SELF.CbSize
  
  !exit if no data
  !if ~recs then
  !  SELF.TakeError('No items have been added to the template.  Add one or more items 1st.')
  !  do procret
  !end
  if ~SELF.cbSize then
    SELF.TakeError('Init was not called.')
    do procret
  end 
  
  !add up the size of the items + 4 bytes for dword alignment   
  loop i= 1 to recs
    get(SELF.DlgItemQ,I)
    TotalSize+=(SELF.DlgItemQ.Datasize + 4)
  end

  SELF.hglobal=globalAlloc(GMEM_MOVEABLE+GMEM_ZeroInit, TotalSize)
  if ~SELF.hglobal then
    SELF.TakeError('Out of memory building dialog template.')
    do procret
  end
  SELF.lpData=Globallock(SELF.Hglobal)
  if ~SELF.lpdata then  
    SELF.TakeError('Out of memory building dialog template.')
    do procret
  end
  SELF.PastBuffer=SELF.lpData + TotalSize
  
  !dlgtemplateex
  !dlgver=1 word
  dummylong=1
  if SELF.write(address(dummylong),2,1) then do procret.
    
  !signature of 0FFFFH (word)  
  dummylong=-1
  if SELF.Write(address(dummylong), 2) then do procret. 
    
  !dwhelpid - ulong  
  if SELF.Write(address(SELF.dwHelpid),4) then do procret.
    
  !dwEXStyle - ulong  
  if SELF.Write(address(SELF.dwExStyle),4) then do procret.
    
  !dwStyle - ulong  
  if SELF.Write(address(SELF.DwStyle),4) then do procret.
    
  !cDlgItems - number of dlg items - word  
  if SELF.Write(address(recs),2) then do procret.
    
  !X position - short 
  if SELF.Write(address(SELF.X),2) then do procret.
    
  !yposition - short  
  if SELF.Write(address(SELF.y),2) then do procret.
 
  !cx - width - short
  if SELF.Write(address(SELF.DlgWidth),2) then do procret.
    
  !cy - height - short  
  if SELF.Write(address(SELF.DlgHeight),2) then do procret.
    
  !menu
  if SELF.MenuResourceId
    !resourceid - write 0FFFFH and then the resourceid - both words
    dummylong=-1
    if SELF.write(address(dummylong),2) then do procret. 
    if SELF.Write(Address(sELF.MenuResourceID), 2) then do procret.
  elsif SELF.cbMenuResourceName then
    !copy the unicode string
    if SELF.Write(Address(SELF.MenuResourceName), SELF.cbMenuResourceName) then do procret.
  else             
    !write a word of zero - no menu
    dummylong=0
    if SELF.Write(Address(dummylong),2) then do procret.  
  end 
     
  !window class 
  if SELF.WindowClassID  then
    !write 0FFFFH then the window class id - both ushort
    dummylong=-1
    if SELF.Write(address(dummylong),2) then do procret. 
    if SELF.Write(address(SELF.WindowClassID),2) then do procret.
  elsif SELF.cbWindowClassName  then 
    !copy the unicode string
    if SELF.Write(Address(SELF.WindowClassName), SELF.cbWindowClassName) then do procret.
  else      
    !write a word of zero - use default dlg class
    dummylong=0
    If SELF.write(Address(dummylong),2) then do procret. 
  end
  
  
  !dialog ititle
  if SELF.cbDlgtitle then
    !write the unicode string if there is a title
    if SELF.Write(Address(SELF.DlgTitle),SELF.cbDlgTitle) then do procret.
  else
    !write a word of zero if not title
    dummylong=0
    if SELF.Write(Address(dummylong),2) then do procret.
  end
  
  
  !if there is any font data, then write that
  if SELF.cbTypefacename then
    if SELF.Write(Address(SELF.pointsize),2) then do procret.
    if SELF.Write(Address(SELF.Weight), 2) then do procret.
    if sELF.Write(Address(SELF.isitalic),1) then do procret.
    if SELF.Write(Address(SELF.charset),1) then do procret.
    if SELF.Write(Address(SELF.TypefaceName),SELF.cbTypefacename) then do procret.
  end    
          
          
  !DlgItemTemplateEX loop            
  loop i= 1 to recs
    get(SELF.DlgItemQ,I)
    !write ulong helpid or 0 and word align
    if SELF.Write(address(SELF.DlgItemQ.DwHelpid),4,1) then do procret.
    !EXStyle - ulong
    if SELF.write(address(SELF.DlgItemQ.dwExStyle),4) then do procret.
    !Style - long  
    if SELF.write(address(SELF.DlgItemQ.dwStyle),4) then do procret.
    !X - short
    if SELF.write(Address(SELF.DlgItemQ.X), 2) then do procret.
    !y - short
    if SELF.write(Address(SELF.DlgItemQ.Y), 2) then do procret.
    !w - short
    if SELF.write(Address(SELF.DlgItemQ.w), 2) then do procret.
    !h - short
    if SELF.write(Address(SELF.DlgItemQ.h), 2) then do procret.
    !ControlID - ushort  
    if SELF.write(Address(SELF.DlgItemQ.controlid), 4) then do procret.
    
    !window class for the control
    if SELF.DlgItemQ.cbClassName then
      if SELF.Write(Address(SELF.DlgItemQ.ClassName), SELF.dlgitemq.cbClassname) then do procret.
    else
      dummylong=-1
      if SELF.Write(address(Dummylong),2) then do procret. 
      if SELF.Write(Address(SELF.DlgItemQ.Classid),2) then do procret.
    end       
    
    !title or resource
    if SELF.DlgItemQ.cbResName then
      if SELF.Write(Address(SELF.DlgItemQ.ResName), SELF.dlgitemq.cbResname) then do procret.
    else
      dummylong=-1
      if SELF.Write(address(Dummylong),2) then do procret. 
      if SELF.Write(Address(SELF.DlgItemQ.Resid),size(SELF.DlgItemQ.Resid)) then do procret.  
    end
    
    
    !extra
    if SeLF.Write(Address(SELF.DlgItemQ.cbCreationdata),2) then do procret.
    if SELF.DlgItemQ.cbCreationData then
      if SELF.Write(SELF.DlgItemQ.lpCreationData, SELF.DlgItemQ.cbCreationdata,1) then do procret.
    end   
  end
              
  !Success
  res=return:benign
  do procret
  
procret routine
  if res=return:benign
    globalUnlock(SELF.hglobal)
    pHGlobal=SELF.hglobal
  else 
    clear(phglobal)
    if SELF.hglobal then
      globalunlock(sELF.hglobal)
      globalFree(sELF.hglobal)
      clear(SELF.hglobal) 
    end
  end    
  return res
  
    
DlgTplCltype.Write procedure(long lpData, long pCbData, byte pDwordAlign=0)
remainder long,auto
res byte(return:fatal)
  code
  if pDwordAlign then
    remainder=SELF.lpData % 4
    if remainder then
      SELF.lpData += (4-Remainder)
    end
  end    
  if pcbdata=0 then return return:benign.
  if pCbData+SELF.lpData>SELF.PastBuffer then
    SELF.TakeError('Attempt to write past the end of the dlgtpl buffer.')
    do procret
  end
  memcpy(SELF.lpData, lpdata, pcbdata)
  SELF.lpData += pcbdata        
  res=return:benign
  do procret
procret routine
  return res  
  
  
DlgTplClType.Test procedure()
Window WINDOW('Open file name'),AT(,,260,100),SYSTEM,GRAY,DOUBLE
       BUTTON('&Test'),AT(104,74,45,14),USE(?Test)
     END

szfile cstring(file:maxfilepath)
OFN like(openfilenametype) !not auto
strfilter string('Tiff<0>*.tif<0>All<0>*.*<0><0>')
cInitial cstring(File:maxfilepath)
hglobal long
WS_POPUP            equate(80000000h)
WS_Caption          equate(0C00000H)
ws_clipSibilings    equate(04000000H) !note there was formerly a bug here where clipsibilings was missing a zero which was really 400000H or ws_dlgframe
ws_clipchildren     equate(02000000H)
WS_popupwindow      equate(80880000h)!ws_popup+ws_border+ws_sysmenu
WS_BORDER           equate(800000H)
ws_group            equate(20000H)

WS_CHILD            EQUATE(40000000H)
WS_VSCROLL          EQUATE(200000H)
WS_HSCROLL          EQUATE(100000H)
WS_TABSTOP          EQUATE(10000H)
ws_visible          equate(10000000H)
WS_THICKFRAME       equate(40000H)
bs_pushbutton       equate(0)
bs_defpushbutton    equate(1)
WS_SYSMENU          equate(80000H)
dlgtitle string('My Dialog')
osvercl osvercltype
verstr string(20)
vernum long
servicepack long
L long,auto
I long,auto
  code
  cPgmpath = command(0)
  L=len(cpgmpath)
  loop i= L to 1 by -1
    if cPgmpath[i]='\' or cpgmpath[i]='/' then
      cpgmpath=cpgmpath[1 : I]
      break
    end
  end

  cInitial=cpgmpath
  osvercl.getos(verstr,vernum,servicepack)
  open(window)
  display()
  accept
    case event()
    of event:openwindow

      if SELF.Init(1,| !debug=true
                   DS_ShellFont+DS_3DLOOK+DS_Control+WS_child+Ws_ClipSibilings,|   !windows style
                   0,| !windows eXStyle
                   230,| !width
                   20,| !Height
                   0,| !x
                   0,| !y
                   0,|DWHELPID
                   0,,| !menu resourceid=0 & menuresourcename (omitted)
                   0,,|   !windowclassid =0 and windowclassname (omitted)
                   ,|  !dlgtitle
                   ) then Message('init')

      elsif SELF.addItem(1,0,WS_Child+BS_PushButton+ws_visible+ws_tabstop,0,60,0,50,14,80H,,0,'&Preview',0,0) then message('Item')
      elsif SELF.GetHandle(hglobal) then message('Gethandle').
    omit('***')
      if SELF.init(1, |!debug
                   WS_CAPTION + WS_SYSMENU + DS_MODALFRAME, |
                   0, | !exstyle
                   200, | !width
                   80, | !height
                   32, | !x
                   32, | !y
                   0, | !dwhelp
                   0,,| !menu resourceid=0 & menuresourcename (omitted)
                   0,,|   !windowclassid =0 and windowclassname (omitted)
                   dlgtitle|  !dlgtitle
                   ) then Message('init')
      elsif SELF.addItem(1,0,WS_Child+BS_defPushButton+ws_visible+ws_tabstop+ws_group,0,75,59,50,14,80H,,0,'OK',0,0) then message('Item')
      elsif SELF.GetHandle(hglobal) then message('Gethandle').


      r#=DialogBoxIndirect(system{prop:appinstance}, globallock(hglobal), 0{prop:handle}, address(explorerhook))
      e#=getLastError()
      message(r#,'result')
      Message('last error='&e#)
    ***
               
    of event:closewindow
      SELF.Kill()
    of event:accepted
      ofn.lStructSize = size(OPENFILENAMEType)
      if vernum<oswin2k then
        ofn.lStructSize-=12
      end
      ofn.hinstance = globallock(hglobal) !system{prop:appinstance}   !HGLOBAL
      ofn.hwndOwner = 0{prop:handle}
      ofn.lpstrFile = address(szFile)
      ofn.nMaxFile = size(szFile);
      ofn.lpstrFilter = address(StrFilter) 
      ofn.nFilterIndex = 1;
      ofn.lpstrFileTitle = 0;
      ofn.nMaxFileTitle = 0;
      ofn.lpstrInitialDir = address(cinitial);
      ofn.lpfnHook =address(explorerhook)
      ofn.Flags = OFN_PATHMUSTEXIST + OFN_FILEMUSTEXIST + OFN_HIDEREADONLY   +OFN_ENABLETEMPLATEHANDLE  + OFN_ENABLEHOOK + ofn_explorer



       if GetOpenFileName(address(ofn)) then
         
          message('file selected, no error')
       else
          message('Error='&CommDlgExtendedError())
       end
       globalunlock(hglobal)
    end !case
  end !accept
  close(window)  
  return

explorerhook  procedure(long phdlg, long pmsg, long pWparam, long plparam)
wm_command equate(111H)
wm_notify  equate(04EH)
CDN_SelChange Equate(-602)
CDM_GetFilePath equate(400H+101)
wm_init equate(110H)
cfilename cstring(File:maxfilepath),auto
thecode long,auto
lpOfn long,auto
ofn &openfilenametype
hwndbutton long,auto
lst1       equate(460H)
hList      long,auto
wm_nextdlgctl equate(28H)
  code
  case pmsg
  of wm_init
    return 1
  of wm_notify
    if pLparam<>0 then
      memcpy(address(thecode),pLparam+8,4)
      if thecode=cdn_selchange then

        !could use this code to get ofn and lpcustomdata if needed - class ref.
        !memcpy(address(lpofn),pLparam+12,4)
        !ofn&=(lpOfn)

        if sendmessage(getparent(phdlg),cdm_getfilepath,size(cFilename), address(cfileName))<>0 then

          hwndbutton = getdlgItem(phdlg,1)  !1= the control id
          if hwndbutton then
            if instring('.TIF',upper(cfilename),1,1) then
              enablewindow(hwndbutton,1)
            else
              enablewindow(hwndbutton,0)
            end
          end
        end

      end
    end
  of wm_command
    if band(pWparam,0FFFFH)=1 then
      !1=controlid for the button - button pushed

      if sendmessage(getparent(phdlg),cdm_getfilepath,size(cFilename), address(cfileName))<>0 then
        if instring('.TIF',upper(cfilename),1,1)<>0 then
          run(cPgmpath & 'gp.exe ' & cfilename,1)
        end
      end
    end
  end
  return 0
