!ABCIncludeFile

OMIT('_EndOfInclude_',_DlgTplClPresent_)
_DlgTplClPresent_ EQUATE(1)

!Other Classes
!  Include('OtherClass.INC')

!Equates - will be seen by using program
ClassID:button    equate(80H)
ClassID:Edit      equate(81H)
ClassID:Static    equate(82H)
ClassID:ListBox   equate(83H)
ClassID:Scrollbar equate(84H)
ClassID:ComboBox  equate(85H)

!dialog styles
DS_3dLook         equate(4)     !almost always used
DS_ABSalign       equate(1)     !dialog box coord are pixels not dlu - rarely used
DS_Center         equate(800H)  !centers window
DS_CenterMouse    equate(1000H) !center dialog box on the location of the mouse cursor
DS_ContextHelp    equate(2000H) !put a ? icon on the toolbar - must process wm_help message
DS_Control        equate(400H)  !creates a dialog box that is a child of another dialog box - used for customizing common dialogs
DS_FixedSys       equate(8)     !caused dialog to use system fixed pitch font rather than the system font.
DS_ModalFrame     equate(80H)   !for a dialog box with a modal frame, title bar, window menu. Needs WS_Caption, WS_Sysmenu
DS_NoFailCreate   equate(10H)   !95-ME only - dialog box created even if child control creation fails
DS_SetForeground  equate(200H)  !bring window to foreground after creation - if not restricted by OS.
DS_SetFont        equate(40H)   !if specified SetFont must be called - allows picking a font.
DS_ShellFont      equate(48H)   !dialog box uses system font, SetFont should NOT be called - and will be set to 'MS Shell Dlg'
                                !combination of ds_setfont+ds_fixedsys
!For modifing a common dialog the most common options are:
! style: DS_ShellFont+DS_Control+WS_Child+WS_ClipSiblings
! exstyle: 0
! No font specified
! x,y=0
! w,H - as needed for your additional controls

dlgItemQType queue,type
dwhelpid     long
dwExStyle    long
dwstyle      long
x            short
y            short
w            short
H            short
controlid    long
classid      short
classname    &string
cbClassName  long
ResID        short
ResName      &string
cbResName    long
cbCreationdata ushort  
lpCreationdata long
Datasize       long  !round to a dword size? !add 3 to ensure can start on a dword boundary
  end
DlgTplClType Class,type,module('DlgTplCl.CLW'),LINK('DlgTplCl.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)

!Member Data
!for error handling
debug     byte
errorstr  string(128)

!for making hglobal
hglobal   long !hglobal containing the dlg item
pastbuffer long !1st byte past the end of the hglobal memory - used for bound checking
cbSize    long !size of the dlg data without item
lpData    long !current pointer to the next byte to write in the hglobal data

strcl     &strcltype !for conversion to wide string

!for dlgitems
DlgItemQ        &DlgItemQType

!dlg data
dwstyle         long
dwExstyle       long
Dlgwidth        short
dlgheight       short
x               short
y               short
dwhelpid        long
MenuresourceID  short
MenuResourceName &string
cbMenuResourceName long
windowClassName &string
windowClassid     short
cbWindowClassName long
DlgTitle        &string
cbDlgTitle        long
typefacename    &string
cbTypefacename    long
pointsize       short
weight          short
isitalic        byte
charset         byte



!Methods - all return 0 for success if they return anything


Init      procedure(byte debug, long dwStyle, long DwExStyle, short pWidth, short pHeight, short px=0, short py=0,|
                    long dwHelpid=0,short pMenuResourceid=0, <string pmenuresourcename>, short windowclassid=0,<string pWindowClassName>, <string pdlgTitle>),byte,proc
TakeError procedure(string pmsg)
Kill      procedure()
DlgFont   procedure(string pTypeface, byte ppointsize, byte pisItalic, long pweight=400, long pCharset=0),byte

additem   procedure(long ControlID, long dwHelpid, long dwstyle, long dwEXStyle, short px, short py, short pWidth, short pheight,|
                    ushort pClassID=0, <String pClassName>,  ushort pResID=0, <string pResName>, ushort cbCreationData=0, long lpCreationData=0),byte
!note: one of pClassid or pClassname must be supplied
!note: one of pResid or pResname must be supplied 
!note: for 95-me controlid must be <=255 (byte)                  
gethandle procedure(*long phglobal),byte

Write procedure(long lpData, long pCbData, byte pDwordAlign=0),byte,private
Test procedure()

    end
 !_EndOfInclude_