  MEMBER


  MAP
  END

  INCLUDE('CCIUTIL.INC')

DosFileName  STRING(File:MaxFilePath+1),STATIC

DosFile      FILE,DRIVER('DOS'),PRE(DOS),NAME(DosFileName)
Record        RECORD
F1             STRING(1000)
              END
             END


cciSelectFileClass.Ask PROCEDURE(BYTE KeepDir=0)

Result    CSTRING(File:MaxFilePath)
x     long

  CODE
  if self.rememberLastFolder
     self.defaultDirectory = GetINI('cciSelectFileClass','baseFolder',,self.INIFileName)
  end
  Result = PARENT.Ask(KeepDir)

  ! If remembering the folders used, get the folder path from the result
  ! and store it in the INI file.
  if self.rememberLastFolder
     loop x = File:MaxFilePath to 1 by -1
        if result[x] = '\'
           PUTINI('cciSelectFileClass','baseFolder',sub(result,1,x),self.INIFileName)
           break
        end
     end
  end

  ! Get the file's size
  DosFileName = result
  open(DosFile)
  if errorcode()
     self.FileSize = -1
     self.FileOpenError = Error()
  else
     self.FileSize = BYTES(DosFile)
     close(DosFile)
  end

  ! If necessary, trim off the leading base folder
  if self.BaseFolder <> '' |
        and len(result) > len(self.BaseFolder) |
        and upper(self.baseFolder) = upper(result[1 : len(self.baseFolder)])
     result = result[len(self.BaseFolder)+1 : len(result)]
  end

  ! If necessary, change \ to /
  if self.useUnixBackslash
     loop x = 1 to len(result)
        if result[x] = '\'
           result[x] = '/'
        end
     end
  end

  return result


cciSelectFileClass.SetRememberLastFolder        PROCEDURE(BYTE save)

  CODE
  self.rememberLastFolder = save


cciSelectFileClass.SetBaseFolder         PROCEDURE(STRING folder)

  CODE
  self.baseFolder = clip(folder)


cciSelectFileClass.getFileSize           PROCEDURE !,LONG

  CODE
  return self.FileSize


cciSelectFileClass.setUseUnixBackslash      PROCEDURE(BYTE backslash)

  CODE
  self.useUnixBackslash = backslash


cciSelectFileClass.setIniFileName            procedure(string filename)
  CODE
  self.IniFileName = filename
